\documentclass[a4paper,11pt]{article}
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage{graphicx}
\usepackage{amsmath}
\usepackage{amssymb}
\title{Computational Finance \\
	\Large Worksheet 1}
\author{Lisa Beer, Alex Dyck, Ho-Yin Leung}
\date{}

\begin{document}
	\maketitle
	\noindent
	\textbf{Task 1.} \\ 
	The underlying code shows two ways for generating uniformly distributed random numbers between 0 and 1. In the first case, the function named rand() is used. It returns a pseudo random integer number between 0 and RAND$\_$MAX (=32767), which is the maximum value returned by rand. By dividing by RAND$\_$MAX we get a pseudo random number between 0 and 1. The output is here 0.001251. If we remove the expression (double), the output is 0, since the rand function has an integer as output and dividing by a (bigger) number results in deleting the decimal places. \\
	The second way uses a random number generator gsl$\_$rng from the GNU Scientific Library. A generator type (here gsl$\_$rng$\_$mt19937) is chosen for allocating the generator. For creating a uniformly distributed number in the range [0,1), the function gsl$\_$rng$\_$uniform is applied to the generator. The function works similar to the first case. A pseudo random integer in the range between 0 and 4294967295 is divided by 4294967296. The output is 0.999742. \\
	The GSL offers a direct function for simulating normally distributed random variables. This function is called gsl$\_$ran$\_$gaussian and generates a normally distributed random variable with mean 0 and variance $\sigma$. By using a transformation one gets normally distributed random variables with mean $\mu$. \\
	\newline
	\textbf{Task 3.} \\ 
	The underlying MATLAB script plots the true density function of the standard normal distribution and the distribution of the data, we have created in task 2.
	First of all, the file values.txt is opened and the values inside the file are stored in the variable data. The function hist returns the distribution of the data values. Hist subdivides the interval, where the data is located, into 100 parts and counts the number of data values are located in each of these parts. The variable vals stores the amount of data values and bins stores the location of these parts. \\
	For plotting the result, the function trapz is used. It calculates the approximation of an integral via the trapezoidal method. Here, the integral of vals is computed, where bins are the increments. For each location in bins, the amount of data values is set in relation to the whole area, which is given by all data in vals. In this way, we plot points lying on  density function of a probability distribution. 
	\begin{figure}
	\centering
	\includegraphics[width=0.8\textwidth]{graphics/rejection_sampling.jpg}	
	\caption{Simulation by rejection sampling}	
	\end{figure}
	Figure 1 shows our result from the simulation of task 2. As we can see, the result is sensible. When we consider the result in figure 1 on the worksheet, one can notice that the points of the rejection sampling are in the middle considerably higher than the density function. The reason for this result is the wrong choice of the interval bounds in the rejection sampling algorithm. Apparently, the interval bounds -2 and 2 are used. However, this interval is too small so that the integral of the density in this interval is considerably smaller than 1. We used -3 and 3 as interval bounds since more than 99$\%$ of all normal distributed values lie in this interval. Thus, this is a suitable choice for the bounds. \\
	\newline
	\textbf{Task 4.} \\ 
	To draw a normally distributed random variable from a uniformly distributed random variable on [0,1], one can use the inverse cumulative distribution function. It yields, that if X is a uniformly distributed random variable on [0,1], then the inverse cumulative distribution of the standard normal distribution applied on X will be the standard normal distribution. \\
	\newline
	\textbf{Task 5.} \\
	The cumulative distribution function of the standard normal distribution is given by
	\begin{equation*}
	F_X(x)=\frac{1}{\sqrt{2\pi}}\int_{-\infty}^{x}\exp^{-\frac{t^2}{2}}dt\textit{.}
	\end{equation*}
	Since there is no analytical expression for this integral, a numerical approximation is needed to compute the c.d.f. and the inverse c.d.f.
	Let us consider first the algorithm for computing the c.d.f. of the standard normal distribution. At the beginning, we use the symmetric property of the normal distribution for the c.d.f., i.e.
	\begin{equation*}
	F_X(-x) = 1 - F_X(x) 
	\end{equation*}
	to consider only the case, where x is positive. Then, we deal with three cases:
	\begin{equation*}
	F_X(x)=\left\{ \begin{array}{lr} 
	\frac{1}{2} + \frac{\sum_{k=0}^{2}A_kx^{2k+1}}{1+\sum_{k=1}^{3}B_kx^{2k}} & 0\le x\le 1.87\\
	1-\left(\frac{\sum_{k=0}^{2}C_kx^k}{\sum_{k=0}^{3}D_kx^k}\right)^{16} & 1.87<x\le 6.0 \\
	1 & \textit{otherwise.} 
	\end{array} \right.
	\end{equation*}
	In the first case, we use the fact, that the c.d.f. at 0 is 0.5 and approximate only the rest of the integral. This is done by a rational approximation. In the second case, we approximate the part, which is missing to capture the whole area under the density function and subtract it from 1. If $x>6$, the algorithms returns 1, since the integral is 1 with a certain accuracy. \\
	Consider now the algorithm for computing the inverse of the c.d.f. We consider three cases:
	\begin{equation*}
	F_X^{-1}(y)=\left\{ \begin{array}{lr} 
	\frac{\sum_{k=0}^{3}E_k(y-0.5)^{2k+1}}{1+\sum_{k=1}^{3}F_k(y-0.5)^{2k+2}} & 0.08\le y\le 0.92\\
	\sum\limits_{k=0}^{8}G_k(\log(-\log(1-y)))^k & y>0.92 \\
	-\sum\limits_{k=0}^{8}G_k(\log(-\log(y)))^k & y<0.08 
	\end{array} \right.
	\end{equation*}	
	In the first case, a rational approximation is used again. In the third case, the symmetry of the normal distribution for the inverse c.d.f. 
	\begin{equation*}
	F_X^{-1}(1-y) = - F_X^{-1}(y) 
	\end{equation*}
	is used to reduce the case to the second case. The second case is a Chebyshev approximation. \\
	\newline
	\textbf{Task 6. and 7.} \\
	Figure 2 shows the 2d-plot of 1000 samples, generated by the Box-Muller method.
	\begin{figure}
		\centering			\includegraphics[width=0.8\textwidth]{graphics/boxmueller.png}	
		\caption{Distribution of 1000 two-dimensional standard Gaussian samples, generated by the Box-Muller method.}	
	\end{figure}
	The Box-Muller method generates a two-dimensional Gaussian sample $(z_1,z_2)$ by taking two uniformly distributed random values $u_1$ and $u_2$ on $[0,1]$ and transform them by 
	\begin{align*}
	z_1 & = \sqrt{-2\log u_1}\cos 2\pi u_2 \\
	z_2 & = \sqrt{-2\log u_1}\sin 2\pi u_2\text{.}
	\end{align*}
	To show, that $z_1$ and $z_2$ are standard normally distributed, we write them in polar coordinates
	\begin{align*}
	z_1 & = r \cos \phi \\
	z_2 & = r \sin \phi 
	\end{align*}
	with
	\begin{equation*}
	r = \sqrt{-2\log u_1} \text{ and }\phi = 2\pi u_2 \text{.}
	\end{equation*}
	Compute first the distribution of $r^2$:
	\begin{align*}
	\mathbb{P}[r^2\le x] & = \mathbb{P}[-2\log u_1 \le x] = \mathbb{P}[\log u_1\ge -\frac{x}{2}] \\ & = 1-\mathbb{P}[u_1<\exp(-\frac{x}{2})] = 1 - \exp(-\frac{x}{2})
	\end{align*}
	In the last equation we used, that $u_1$ is uniformly distributed. The distribution of $\phi$ is given by
	\begin{align*}
	\mathbb{P}[\phi\le x]=\mathbb{P}[2\pi u_2\le x]=\mathbb{P}[u_2\le \frac{x}{2\pi}]=\frac{x}{2\pi} \text{ for }0<x<2\pi
	\end{align*}
	Thus $r^2\sim\text{Exp}(\frac{1}{2})$ and $\phi\sim\mathcal{U}(0,2\pi)$. For the joint distribution of $z_1$ and $z_2$ we get
	\begin{equation*}
	p(x,y) = \left(\frac{1}{2\pi}\right)\left(\exp^{-\frac{r^2}{2}}\right) = \frac{1}{2\pi}\exp^{-\frac{(x^2+y^2)}{2}}\text{,}
	\end{equation*}
	where $r^2=x^2+y^2$. Since $u_1$ and $u_2$ are independent, $z_1$ are $z_2$ are independent, too. So we can write
	\begin{equation*}
	p(x,y) = p(x) p(y)  = \left(\frac{1}{2\pi}\exp^{-\frac{x^2}{2}}\right)	\left(\frac{1}{2\pi}\exp^{-\frac{x^2}{2}}\right)\text{.}
	\end{equation*}
	Thus, $z_1$ and $z_2$ are independent standard normally distributed random variables.
	\\
	\newline
	\textbf{Task 8.} \\ 
	To compute the sample variance the underlying algorithm uses the following recursion:
	\begin{align*}
	\alpha_1 & = x_1 \\
	\alpha_n & = \frac{x_n}{n}+\frac{n-1}{n}\alpha_{n-1} \text{ for } n>=2 \\
	\beta_1 & = 0 \\
	\beta_n & = \beta_{n-1}+\frac{n-1}{n}(x_n-\alpha_{n-1})^2 \text{ for } n>=2 \\
	\hat{\sigma}^2 & =\frac{\beta_N}{N}
	\end{align*}
	We show that this algorithm is correct. We denote $\hat{\mu}_n$ as the sample mean for the first n samples. We notice that $\alpha_n = \hat{\mu}_n$:
	\begin{align*}
	\hat{\mu}_1 &= x_1 = \alpha_1 \\
	\hat{\mu}_n &= \frac{1}{n}\sum_{i=1}^{n}x_i = \frac{x_n}{n}+\frac{1}{n}\sum_{i=1}^{n-1}x_i = \frac{x_n}{n}+\frac{n-1}{n}\hat{\mu}_{n-1}
	\end{align*}
	Now we consider the sum of the sample variance.
	\begin{align*}
	\sum_{i=1}^{n}(x_i-\hat{\mu})^2&=\sum_{i=1}^{n}(x_i^2-2\hat{\mu}x_i+\hat{\mu}^2)=\sum_{i=1}^{n}x_i^2-2\hat{\mu}\sum_{i=1}^{n}x_i+n\hat{\mu}^2 \\ 
	&= \sum_{i=1}^{n}x_i^2-n\hat{\mu}^2 = x_n^2+\sum_{i=1}^{n-1}x_i^2-\frac{1}{n}(\sum_{j=1}^{n-1}x_j+x_n)^2 \\
	&= x_n^2+\sum_{i=1}^{n-1}x_i^2-\frac{1}{n}\left(\sum_{j=1}^{n-1}x_j\right)^2-\frac{2}{n}\sum_{j=1}^{n-1}x_jx_n - \frac{x_n^2}{n} \\
	&= \sum_{i=1}^{n-1}x_i^2 -(n-1)\hat{\mu}_{n-1}^2 + \frac{n-1}{n}\hat{\mu}_{n-1}^2-\frac{2}{n}\sum_{j=1}^{n-1}x_jx_n+\frac{n-1}{n}x_n^2 \\
	&= \sum_{i=1}^{n-1}(x_i-\hat{\mu}_{n-1})^2+\frac{n-1}{n}(x_n-\hat{\mu}_{n-1})^2
	\end{align*}
	But this is the same recursion formula as for $\beta_n$. Thus, the algorithm is correct. The advantage of this algorithm in contrast to the naive computation of the sample variance is that we only need one loop for computing it, so it is more efficient than the naive approach.
	\\
	\newline
	\textbf{Task 9.} \\ 
	For the loglog-convergence plot we selected $\mu = 2$ and 0.1, 1.0 and 10.0 for $\sigma$.
	\begin{figure}
			\centering			\includegraphics[width=0.8\textwidth]{graphics/estimation.png}	
			\caption{The loglog-convergence plot of the estimation error $|\sigma-\hat{\sigma}|$ with respect to the number of samples $N$.}	
	\end{figure}
	One can see the result in figure 3. Firstly, one can observe that the estimation error gets smaller the more samples we use. Thus, the sample variance, indeed, converges to the true variance. When we compare the estimation error for the three different values for $\sigma$, one notices that the estimation error is smaller, if the true variance is smaller. The reason for that could be if the true variance is small, there is less deviation in the samples and the sample variance can be better approximated then.
	\\
	\newline
	\textbf{Task 10.} \\
	The figure 4 and 5 show simulation examples of a Wiener process and the corresponding asset price with different time discritization.
	\begin{figure}
		\centering			
		\includegraphics[width=0.8\textwidth]{graphics/geometricBrownianMotion.png}	
		\caption{Top: Asset prices with different time discretizations. Bottom: Underlying Wiener process}	
	\end{figure}
	In our case, as one can see, the paths look all similar except for one. Since the sample sizes of the paths and $\Delta$T are not enough, we cannot make any conclusion that the paths are independent of the time discretization. Even we reject the extreme path, it is hard to predict the price will increase approximately +10\%year. Since at T= 0.5, 1 and 1.5, some paths slightly increase and the others decrease. The mean changes of price approximately not increase. However, at T = 2, paths tend to the same and the right value and have a trend to increase. The result is not significant enough and longer T is needed to make a conclusion.
	\\
	\newline \newline
	\textbf{Task 11.} \\
	We know that for the geometric Brownian motion $S(t)$ at time t, it yields that $\log(S(t)/S(0)$ is normally distributed with mean value $(\mu-\frac{1}{2}\sigma^2)t$ and variance $\sigma^2t$. To estimate the drift $\mu$ and the volatility $\sigma$ from the given GBM path at the point $\{t_i\}_{i=0}^M$ we consider the following statement:
	\begin{equation*}
	\log(S(t_{i+1})/S(0))-\log(S(t_{i})/S(0))\sim \mathcal{N}((\mu-\frac{1}{2}\sigma^2)\Delta t,\sigma^2\Delta t)
	\end{equation*}
	Thus, we can use the difference of these two logarithms to estimate $\sigma\sqrt{\Delta t}$ with the sample deviation algorithm from task 8 and estimate $(\mu-\frac{1}{2}\sigma^2)\Delta t$ with the sample mean. By applying the estimation of $\sigma$, one gets an estimation of the drift $\mu$. In our case, where we used $\sigma = 0.2$ and $\mu = 0.1$ for the simulation, we get $\hat{\sigma}=0.200974$ and $\hat{\mu}=0.171191$ as estimations.
\end{document}
